#BLSZ = 16

UsePNGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageEncoder()

Global Dim blc.f(#BLSZ-1, #BLSZ-1)
Global Dim scene(1024,1024)


CatchImage(1,?block)
StartDrawing(ImageOutput(1))
For y=0 To #BLSZ-1
  For x=0 To #BLSZ-1
    blc(x,y) = Green(Point(x,y))/255.0 - 0.5
  Next
Next  
StopDrawing()

CreateImage(2,1024,1024, 32)


;FILE$ = ProgramParameter(0)


If OpenWindow(1, 0, 0, 900, 600, "LEGO - Movie", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  
  ButtonGadget(0, 10, 10, 80, 20, "Path")  
  ButtonGadget(1, 10, 40, 80, 20, "Play")
  CheckBoxGadget(2, 10, 80, 80, 20, "Save")
  
  TextGadget(3, 10, 120, 60,20, "Frames/sec")
  SpinGadget(4, 10,140, 80, 20, 1, 25,#PB_Spin_Numeric );
  SetGadgetState(4,10)
  TextGadget(5, 10, 170, 70,20, "Frames:")  
EndIf


Repeat
  
  ev = WaitWindowEvent()
  
  
  If ev = #PB_Event_Gadget And EventGadget()=0
    SetCurrentDirectory( PathRequester("Select path of frames (frame-0000.png, frame-0001.png ... )", GetCurrentDirectory()) )
  EndIf  
  
  If ev = #PB_Event_Gadget And EventGadget()=1
    do = 1
    frame = 0
    
    delay.f = 1000.0 / GetGadgetState(4)
    
    START_GES = ElapsedMilliseconds()
    
    While do
      
      
      FILE$= "frame-"+RSet(Str(frame),4,"0")+".png" 
      
      If FileSize(FILE$) > 0
        START = ElapsedMilliseconds()
        LoadImage(1,FILE$)
        
        StartDrawing(ImageOutput(1))
        For y=0 To ImageHeight(1)-1
          For x=0 To ImageWidth(1)-1
            scene(x,y) = Point(x,y)
          Next
        Next  
        StopDrawing()
        
        
        If ImageWidth(2) <> ImageWidth(1)*#BLSZ Or ImageHeight(2) <> ImageHeight(1)*#BLSZ         
          CreateImage(2,ImageWidth(1)*#BLSZ, ImageHeight(1)*#BLSZ, 32)
        EndIf  
        StartDrawing(ImageOutput(2))
        
        addr = DrawingBuffer()
        pitch = DrawingBufferPitch()
        height2 = ImageHeight(2)-1
        
        
        width1= ImageWidth(1)-1
        height1 = ImageHeight(1)-1
        bz = #BLSZ-1
        
        
        If DrawingBufferPixelFormat() = #PB_PixelFormat_32Bits_RGB
          For y=0 To height1
            For x=0 To width1
              
              pixel = scene(x,y)
              c_R.f = Red(pixel) *0.0039215689
              c_G.f = Green(pixel) *0.0039215689
              c_B.f = Blue(pixel) * 0.0039215689
              
              For by =0 To bz  
                ptr = addr + ( ((y) * #BLSZ + by)) * pitch + (x * #BLSZ) << 2
                For bx =0 To bz
                  
                  gray.f = blc(bx,by)
                  ir = (gray + c_R ) * 255.0
                  ig = (gray + c_G ) * 255.0
                  ib = (gray + c_B ) * 255.0
                  
                  If ir > 255: ir = 255:EndIf
                  If ir < 0:ir = 0:EndIf
                  
                  If ig > 255: ig = 255:EndIf
                  If ig < 0:ig = 0:EndIf
                  
                  If ib > 255: ib = 255:EndIf
                  If ib < 0:ib = 0:EndIf                
                  
                  PokeL(ptr,RGBA(ir,ig,ib,255))
                  ptr+4
                Next
              Next
            Next
          Next  
        Else
          For y=0 To height1
            For x=0 To width1
              
              pixel = scene(x,y)
              c_R.f = Red(pixel) *0.0039215689
              c_G.f = Green(pixel) *0.0039215689
              c_B.f = Blue(pixel) * 0.0039215689
              
              For by =0 To bz  
                ptr = addr + ((height2) - ((y) * #BLSZ + by)) * pitch + (x * #BLSZ) << 2
                For bx =0 To bz
                  
                  gray.f = blc(bx,by)
                  ir = (gray + c_R ) * 255.0
                  ig = (gray + c_G ) * 255.0
                  ib = (gray + c_B ) * 255.0
                  
                  If ir > 255: ir = 255:EndIf
                  If ir < 0:ir = 0:EndIf
                  
                  If ig > 255: ig = 255:EndIf
                  If ig < 0:ig = 0:EndIf
                  
                  If ib > 255: ib = 255:EndIf
                  If ib < 0:ib = 0:EndIf                
                  
                  PokeL(ptr,RGBA(ir,ig,ib,255))
                  ptr+4
                Next
              Next
            Next
          Next  
        
        EndIf
        StopDrawing()
        
            
        StartDrawing(WindowOutput(1)) 
        DrawImage(ImageID(2),100,0,WindowWidth(1)-100, WindowHeight(1))
        StopDrawing()
        
        While (ElapsedMilliseconds()-start < delay)
          !PAUSE
        Wend  
        
        If GetGadgetState(2)
          SaveImage(2, "frame-lego-"+RSet(Str(frame),4,"0")+".png",  #PB_ImagePlugin_PNG)
        EndIf
      Else
        do = 0
      EndIf
      
      While WindowEvent()<>0
      Wend  
           
      frame+1  
    Wend
    
    
    abz.f = (ElapsedMilliseconds()-START_GES ) * (1.0 / frame)
    fps.f = (1000.0) / abz
    SetGadgetText(5, "Frames:" + StrF(fps,1))
    
  EndIf
  
Until ev = #PB_Event_CloseWindow

End

DataSection
  block:
  IncludeBinary "lego16x16.png"
EndDataSection  
; IDE Options = PureBasic 5.00 Beta 6 (Windows - x86)
; CursorPosition = 115
; FirstLine = 78
; EnableXP
; Executable = ..\legoimg.exe